from __future__ import with_statement
from pasteob import wapp_mw
from pasteob.auth.logic import webauth_logic
from mext.context import Setting, State, _ClassDelegate

__all__ = ['creq', 'creq_mw', 'CAuth']

_creq = Setting()

class CurrentRequest(object):
    get = _creq.get
    def __getattr__(self, name):
        req = _creq.get()
        if req is None:
            raise RuntimeError("No current request")
        return getattr(req, name)

    def __setattr__(self, name, value):
        raise AttributeError("creq attrs are not settable")


creq = CurrentRequest()

@wapp_mw
def creq_mw(req, app, stateful_iter=False):
    with State.child():
        _creq.set(req)
        r = app << req
        if stateful_iter:
            r.flat_app_iter()
        return r

class CAuth(_ClassDelegate):
    # properties and methods to be implemented in every logic
    logged_in = user = None
    login_url = logout_url = None
    require_user = None

    @staticmethod
    def get():
        # identical to return WebAuth(creq.get())
        req = creq.get()
        logic_factory = webauth_logic.get()
        return logic_factory(req)
